#!/usr/local/bin/perl
##############################################################################
# WWWBoard                      Version 2.0 ALPHA 2                          #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
# Define Variables

$basedir = "/data1/hypermart.net/freeland/forum";
$baseurl = "http://freeland.hypermart.net/forum";
$page_url = "http://freeland.hypermart.net/forum/mainpage.pl";

$addnewfile = "addnew.html";
$mesgfile = "mainboard.html";

$title = "̳ҳ";

# Done
###########################################################################

###########################################################################
# Configure Options

$posts_per_page = 100;

# Done
###########################################################################
# Get Form Information
&parse_form;

# Read Forum Main Page
&main_page;

#######################
# Parse Form Subroutine

sub parse_form {

   $req=$ENV{'REQUEST_METHOD'};

   # Get the input

   if ($ENV{'REQUEST_METHOD'} eq "GET")
   {
        $buffer = $ENV{'QUERY_STRING'};
   }
   else
   {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   }

   # Split the name-value pairs
   @pairs = split(/&/, $buffer);

   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      # Un-Webify plus signs and %-encoding
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;

      if ($allow_html != 1) {
         $value =~ s/<([^>]|\n)*>//g;
      }
      else {
         unless ($name eq 'body') {
         $value =~ s/<([^>]|\n)*>//g;
         }
      }

      $FORM{$name} = $value;
   }
}

###############################
# Main WWWBoard Page Subroutine

sub main_page {
   open(MAIN,"$basedir/$mesgfile") || die $!;
   @main = <MAIN>;
   close(MAIN);

   print "Content-type: text/html\n\n";

   $index_flag = 0;
   $line_counter = 0;
   $ul_flag = 0;
   $disp_flag = 0;

   $pageno = $FORM{"pageno"};

   if (!$pageno) { $pageno = 1;}
   $pageno_next = $pageno + 1;
   $pageno_prev = $pageno - 1;

   if ($pageno_prev < 1) { $pageno_prev = 1; }

   print "<html> \n";
   print "<head> \n";
   print "<title>̳</title> \n";
   print "</head> \n";
   print "<body bgcolor=\"E5E5E5\"> \n";
   
   print " [ <a href=\"$baseurl/$addnewfile\"> </a> \n";
   print " ][ <a href=\"$page_url?pageno=1\"> һҳ</a> \n";
   print " ][ <a href=\"$page_url?pageno=$pageno_next\"> һҳ</a> \n";
   print " ][ <a href=\"$page_url?pageno=$pageno_prev\"> һҳ</a> ]<p>\n";

   print "<!--#echo banner=\"\"-->\n";

   if ($pageno == 1)
   {
      print"<center><h1>̳</h1></center> \n";
      print "<center>zzz Email: <a href=\"mailto:zzz\@hotmail.com\">zzz\@hotmail.com</a><p></center> \n";
   }

   print "<center> $pageno ҳ</center> \n";
   print "<center><hr size=7 width=75%></center> \n";

   print "<ul> \n";

   foreach $main_line (@main) {

       if ($main_line =~ /<!--begin-->/)
       {
	   $index_flag = 1;
       }

       if ($main_line =~ /<!--end-->/)
       {
	   $index_flag = 0;
       }

       if ($index_flag == 1) 
       {
	    if ($main_line =~ /<ul>/) { $ul_flag++; }

	    if ($main_line =~ /<\/ul>/) { $ul_flag--; }

 	    if ($main_line =~ /<!--top/) { $line_counter++; }

	    if ($ul_flag == 0 && $line_counter > (($pageno-1)*$posts_per_page) && $main_line =~ /<!--top/ ) { $disp_flag = 1; }

	    if ($ul_flag == 0 && $line_counter > ($pageno*$posts_per_page) && $main_line =~ /<!--top/ ) { $disp_flag = 0; last; }

            if ($disp_flag == 1) 
	    { 
	    	$main_line =~ s/<b>//g;
	    	$main_line =~ s/<\/b>//g;

		print "$main_line"; 
	    }	
       }

   }

   print "</ul> \n";
   print "<hr size=7 width=75%> \n";
   print "<BR> \n";

   print " [ <a href=\"$baseurl/$addnewfile\"> </a> \n";
   print " ][ <a href=\"$page_url?pageno=1\"> һҳ</a> \n";
   print " ][ <a href=\"$page_url?pageno=$pageno_next\"> һҳ</a> \n";
   print " ][ <a href=\"$page_url?pageno=$pageno_prev\"> һҳ</a> ]<p>\n";

   print "</body></html> \n";

}
